'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.observableMiddleware = observableMiddleware;
exports.observableFromStore = observableFromStore;

var _fluxStandardAction = require('flux-standard-action');

var _rx = require('rx');

function isObservable(val) {
  return val instanceof _rx.Observable;
}

function observableMiddleware(next) {
  return function (action) {
    if (!_fluxStandardAction.isFSA(action)) {
      return isObservable(action) ? action.doOnNext(next) : next(action);
    }

    return isObservable(action.payload) ? action.payload.doOnNext(function (x) {
      return next(_extends({}, action, { payload: x, status: 'success' }));
    }).doOnError(function (e) {
      return next(_extends({}, action, { payload: e, status: 'error' }));
    }) : next(action);
  };
}

function observableFromStore(store) {
  return _rx.Observable.create(function (observer) {
    return store.subscribe(function () {
      return observer.onNext(store.getState());
    });
  });
}